#!/bin/sh

# ------------------------------------------------------------------------------
# YourKit Java Profiler startup script
# ------------------------------------------------------------------------------

_YH_=`dirname "$0"`/..
if [ ! -r "$_YH_/lib/yjp.jar" ] ; then
  echo "Cannot start YourKit Java Profiler."
  echo "Please launch yjp.sh with {YourKit Java Profiler Home}/bin as working directory."
  exit
fi

if [ "`uname -a | grep HP-UX`" ] ; then
  JAVA_EXE="/opt/java6/bin/java"
  TOOLS_JAR_OPTION="-Xbootclasspath/a:/opt/java6/lib/tools.jar"
elif [ "`uname -a | grep SunOS`" ] ; then
  JAVA_EXE="/usr/jdk/instances/jdk1.6.0/bin/java"
  TOOLS_JAR_OPTION="-Xbootclasspath/a:/usr/jdk/instances/jdk1.6.0/lib/tools.jar"
elif [ "`uname -a | grep Linux`" ] && [ "`uname -a | grep x86_64`" ] ; then
  JAVA_EXE="$_YH_/jre64/bin/java"
  TOOLS_JAR_OPTION="-Xbootclasspath/a:$_YH_/lib/tools.jar"
else
  JAVA_EXE="$_YH_/jre/bin/java"
  TOOLS_JAR_OPTION="-Xbootclasspath/a:$_YH_/lib/tools.jar"
fi

if [ ! -r "$JAVA_EXE" ] ; then
  JAVA_EXE="$YJP_JAVA_HOME/bin/java"
  TOOLS_JAR_OPTION="-Xbootclasspath/a:$YJP_JAVA_HOME/lib/tools.jar"
  if [ -z "$YJP_JAVA_HOME" ] || [ ! -r "$JAVA_EXE" ] ; then
    JAVA_EXE="$JAVA_HOME/bin/java"
    TOOLS_JAR_OPTION="-Xbootclasspath/a:$JAVA_HOME/lib/tools.jar"
    if [ -z "$JAVA_HOME" ] || [ ! -r "$JAVA_EXE" ] ; then
      JAVA_EXE=java
      TOOLS_JAR_OPTION=""
      JVM_VERSION=`java -version 2>&1 | grep version`
      if [ -z "$JVM_VERSION" ] ; then
        echo "To run YourKit Java Profiler Java 6 or newer should be available."
        echo "Please make sure you have 'java' in your current PATH"
        echo "or set YJP_JAVA_HOME or JAVA_HOME environment variable to Java installation directory."
        exit
      fi
    fi
  fi
fi

JAVA_TOOL_OPTIONS=
export JAVA_TOOL_OPTIONS

# On Solaris and HP-UX, use 64-bit JVM, if available
if [ "`uname -a | grep SunOS`" ] || [ "`uname -a | grep HP-UX`" ] ; then
  if [ "`$JAVA_EXE -d64 -version 2>&1 | grep 64-Bit`" ] ; then
    JAVA_EXE="$JAVA_EXE -d64"
  fi
fi

if [ "`$JAVA_EXE -version 2>&1 | grep 64-Bit`" ] ; then
  # 64-Bit Java
  JAVA_HEAP_LIMIT="-Xmx2048m -XX:PermSize=256m -XX:MaxPermSize=256m"
else
  # 32-Bit Java
  JAVA_HEAP_LIMIT="-Xmx512m -XX:PermSize=64m -XX:MaxPermSize=64m"
fi

INI_PARAMS="`cat $_YH_/bin/yjp.ini | grep -v '#'`"
exec $JAVA_EXE $JAVA_HEAP_LIMIT $INI_PARAMS $TOOLS_JAR_OPTION -jar "$_YH_/lib/yjp.jar" $1 $2 $3 $4 $5 $6 $7 $8 $9
